RetentionPolicy (Java SE 10 & JDK 10 )
Keywords: java.lang.annotation.RetentionPolicy class

Module java.base
Package java.lang.annotation

## Enum RetentionPolicy

- java.lang.Object
- - java.lang.Enum<RetentionPolicy>
  - - java.lang.annotation.RetentionPolicy

- All Implemented Interfaces:
    `Serializable`, `Comparable<RetentionPolicy>`

      public enum RetentionPolicy
      extends Enum<RetentionPolicy>

  Annotation retention policy. The constants of this enumerated type describe the various policies for retaining annotations. They are used in conjunction with the `Retention` meta-annotation type to specify how long annotations are to be retained.
  Since:
    1.5

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant | Description
    --- | ---
    `CLASS` | Annotations are to be recorded in the class file by the compiler but need not be retained by the VM at run time.
    `RUNTIME` | Annotations are to be recorded in the class file by the compiler and retained by the VM at run time, so they may be read reflectively.
    `SOURCE` | Annotations are to be discarded by the compiler.

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static RetentionPolicy` | `valueOf​(String name)` | Returns the enum constant of this type with the specified name.
    `static RetentionPolicy[]` | `values()` | Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods declared in class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods declared in class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### SOURCE

          public static final RetentionPolicy SOURCE

      Annotations are to be discarded by the compiler.

    - #### CLASS

          public static final RetentionPolicy CLASS

      Annotations are to be recorded in the class file by the compiler but need not be retained by the VM at run time. This is the default behavior.

    - #### RUNTIME

          public static final RetentionPolicy RUNTIME

      Annotations are to be recorded in the class file by the compiler and retained by the VM at run time, so they may be read reflectively.
      See Also:
        `AnnotatedElement`

  - ### Method Detail

    - #### values

          public static RetentionPolicy[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (RetentionPolicy c : RetentionPolicy.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static RetentionPolicy valueOf​(String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `IllegalArgumentException` - if this enum type has no constant with the specified name
        `NullPointerException` - if the argument is null